/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.util.chinese;

import com.jiuqi.util.chinese.NotValidChineseDigitException;
import java.io.Serializable;

class ChineseDigit
implements Comparable,
Cloneable,
Serializable {
    private static final char[] SMALL_DIGITS = new char[]{'\u25cb', '\u4e00', '\u4e8c', '\u4e09', '\u56db', '\u4e94', '\u516d', '\u4e03', '\u516b', '\u4e5d'};
    private static final char[] BIG_DIGITS = new char[]{'\u96f6', '\u58f9', '\u8d30', '\u53c1', '\u8086', '\u4f0d', '\u9646', '\u67d2', '\u634c', '\u7396'};
    private static char bufferedChar = '\u0000';
    private static int bufferedValue = -1;
    private int digit;

    public ChineseDigit() {
        this.digit = 0;
    }

    public ChineseDigit(int dig) {
        if (dig < 0 || dig > 9) {
            throw new IllegalArgumentException("只能从0-9的阿拉伯数字来建立对象！");
        }
        this.digit = dig;
    }

    public ChineseDigit(char digChar) throws NotValidChineseDigitException {
        int value = digChar - 48;
        this.digit = value >= 0 && value <= 9 ? value : ChineseDigit.valueOf(digChar);
    }

    public int intValue() {
        return this.digit;
    }

    public char chineseValue(boolean useBigChar) {
        return ChineseDigit.toChineseChar(this.digit, useBigChar);
    }

    public static int valueOf(char chDig) throws NotValidChineseDigitException {
        if (bufferedChar == chDig) {
            return bufferedValue;
        }
        int position = -1;
        int i = 0;
        while (i < SMALL_DIGITS.length) {
            if (chDig == SMALL_DIGITS[i]) {
                position = i;
                break;
            }
            ++i;
        }
        if (position != -1) {
            bufferedChar = chDig;
            bufferedValue = position;
            return position;
        }
        i = 0;
        while (i < BIG_DIGITS.length) {
            if (chDig == BIG_DIGITS[i]) {
                position = i;
                break;
            }
            ++i;
        }
        if (position != -1) {
            bufferedChar = chDig;
            bufferedValue = position;
            return position;
        }
        throw new NotValidChineseDigitException("字符\"" + chDig + "\"不是一个中文的数字字符！");
    }

    public static char toChineseChar(int value, boolean useBigChar) {
        if (value >= 0 && value <= 9) {
            if (!useBigChar) {
                return SMALL_DIGITS[value];
            }
            return BIG_DIGITS[value];
        }
        throw new IllegalArgumentException("整型参数值\"" + value + "\"必须在0-9之间！");
    }

    public static boolean isValidChineseDigit(char value) {
        try {
            ChineseDigit.valueOf(value);
            return true;
        }
        catch (NotValidChineseDigitException notValidChineseDigitException) {
            return false;
        }
    }

    public Object clone() {
        return new ChineseDigit(this.digit);
    }

    public boolean equals(Object o) {
        if (o == this) {
            return true;
        }
        if (!(o instanceof ChineseDigit)) {
            return false;
        }
        ChineseDigit value = (ChineseDigit)o;
        return this.digit == value.digit;
    }

    public int hashCode() {
        int result = super.hashCode();
        int hc1 = this.digit;
        result = 37 * result + hc1;
        return result;
    }

    public String toString() {
        return String.valueOf(this.chineseValue(false));
    }

    public int compareTo(Object o) {
        ChineseDigit value = (ChineseDigit)o;
        return this.digit - value.digit;
    }
}

